signature CE3DMATRIX =
  sig
    include CEMULTARITH;
    structure ang  : CE3DANGLE;
    structure vert : CE3DVERTEX;
    structure vec  : CE3DVECTOR;
                        
    (* construct new matrices *)
    val genericMatrix : ((real* real* real* real)*
                         (real* real* real* real)*
                         (real* real* real* real)*
                         (real* real* real* real)) -> t;
    val rotateXMatrixSin : (real*real)->t;
    val rotateXMatrix : ang.angle->t;
    val rotateYMatrixSin : (real*real)->t;
    val rotateYMatrix : ang.angle->t;
    val rotateZMatrixSin : (real*real)->t;
    val rotateZMatrix : ang.angle->t;
    val scaleXYZMatrix : (real*real*real)->t;
    val translateXYZMatrix : (real*real*real)->t;
    val shearXYMatrix : (real*real)->t;
    val shearXZMatrix : (real*real)->t;
    val shearYZMatrix : (real*real)->t;
    val swapLRCoordsysMatrix : unit->t;(* Not tested! *)

    (* modify existing matrices *)
    val scaleXYZ : t*real*real*real->t;
    val rotateXsin : t*real*real->t;
    val rotateX : t*ang.angle->t;
    val rotateYsin : t*real*real->t;
    val rotateY : t*ang.angle->t;
    val rotateZsin : t*real*real->t;
    val rotateZ : t*ang.angle->t;
    val translateXYZ : t*real*real*real->t;
    val shearXY  : t*real*real->t;
    val shearXZ  : t*real*real->t;
    val shearYZ  : t*real*real->t;
    val swapLRCoordsys : t->t;(* Not tested *)

    (* transform vertices *)
    val transformVertexFunction : t->(vert.vertex->vert.vertex);
  end;
