signature CEADDARITH = (* Addition arithmetic *)
  sig
    type t;
    exception Divide;(* FIXME: Should be a general exception *)

    val zeroValue       : t;(* When zeroValue is added to t, the result is t *)
    val add             : (t* t) -> t;
    val subtract        : (t* t) -> t;
    val negate          : t -> t;(* Inverse number for add *)
    val scalarMultiply  : (t* real) -> t;
    val scalarDivide    : (t* real) -> t;
    
    val equal           : (t* t) -> bool;(* Comparison *)
  end
;

signature CEMULTARITH = (* Multiplication arithmetic *)
  sig
    include CEADDARITH;(* Supports all addition arithmetics *)
    
    val unitValue       : t;(* When unitValue is multiplied by t, the result is t *)
    val multiply        : (t* t) -> t;
    val divide          : (t* t) -> t;
    val reciprocal      : t -> t;(* Inverse number for multiply *)
  end
;